Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material	(revision 2175)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material	(revision 2179)
@@ -123,8 +123,13 @@
 			 {
 					max_light_count 3
-					vertex_program_name GameTools/ShadowMap/ShadowDistVS
-					fragment_program_name GameTools/ShadowMap/ShadowDistPS
-					set_light_view true
-					set_light_farplane true
+					vertex_program_name GTP/Basic/LightCPos_VS
+					fragment_program_name GTP/Basic/SM/Dist_VSM_PS
+					set_light_view true
+					set_light_farplane true
+					light_viewproj_param_name LightViewProj
+					light_view_param_name LightView
+					light_farplane_param_name lightFarPlane
+					world_view_proj_param_name WorldViewProj
+					world_param_name World
 			 }					
 		    }	
@@ -154,8 +159,13 @@
 			 {
 					max_light_count 3
-					vertex_program_name GameTools/ShadowMap/ShadowDistVS
-					fragment_program_name GameTools/ShadowMap/ShadowDistPS
-					set_light_view true
-					set_light_farplane true
+					vertex_program_name GTP/Basic/LightCPos_VS
+					fragment_program_name GTP/Basic/SM/Dist_VSM_PS
+					set_light_view true
+					set_light_farplane true
+					light_viewproj_param_name LightViewProj
+					light_view_param_name LightView
+					light_farplane_param_name lightFarPlane
+					world_view_proj_param_name WorldViewProj
+					world_param_name World
 			 }					
 		    }	
@@ -206,8 +216,13 @@
 			{
 					max_light_count 3
-					vertex_program_name GameTools/ShadowMap/ShadowDistVS
-					fragment_program_name GameTools/ShadowMap/ShadowDistPS
-					set_light_view true
-					set_light_farplane true
+					vertex_program_name GTP/Basic/LightCPos_VS
+					fragment_program_name GTP/Basic/SM/Dist_VSM_PS
+					set_light_view true
+					set_light_farplane true
+					light_viewproj_param_name LightViewProj
+					light_view_param_name LightView
+					light_farplane_param_name lightFarPlane
+					world_view_proj_param_name WorldViewProj
+					world_param_name World
 			}					
 		}	
@@ -244,8 +259,13 @@
 			{
 					max_light_count 3
-					vertex_program_name GameTools/ShadowMap/ShadowDistVS
-					fragment_program_name GameTools/ShadowMap/ShadowDistPS
-					set_light_view true
-					set_light_farplane true
+					vertex_program_name GTP/Basic/LightCPos_VS
+					fragment_program_name GTP/Basic/SM/Dist_VSM_PS
+					set_light_view true
+					set_light_farplane true
+					light_viewproj_param_name LightViewProj
+					light_view_param_name LightView
+					light_farplane_param_name lightFarPlane
+					world_view_proj_param_name WorldViewProj
+					world_param_name World
 			}					
 		}	
@@ -300,8 +320,13 @@
 			{
 					max_light_count 3
-					vertex_program_name GameTools/ShadowMap/ShadowDistVS
-					fragment_program_name GameTools/ShadowMap/ShadowDistPS
-					set_light_view true
-					set_light_farplane true
+					vertex_program_name GTP/Basic/LightCPos_VS
+					fragment_program_name GTP/Basic/SM/Dist_VSM_PS
+					set_light_view true
+					set_light_farplane true
+					light_viewproj_param_name LightViewProj
+					light_view_param_name LightView
+					light_farplane_param_name lightFarPlane
+					world_view_proj_param_name WorldViewProj
+					world_param_name World
 			}					
 		}	
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl	(revision 2024)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl	(revision 2179)
@@ -28,5 +28,5 @@
 {
  float4 pos = IN.VPosition / IN.VPosition.w;
- return float4(pos.z, pos.z * pos.z, 1, 1);	
+ return float4(pos.z, pos.z * pos.z, 0, pos.z);	
 }
 
@@ -39,4 +39,11 @@
 {
  float dist = length(IN.CPos.xyz);
+ return float4(dist, dist * dist, 1, dist);	
+}
+
+float4 CDistNorm(CPos_OUT IN,
+				uniform float farPlane) : COLOR
+{
+ float dist = length(IN.CPos.xyz) / farPlane;
  return float4(dist, dist * dist, 1, dist);	
 }
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowMap_PS.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowMap_PS.hlsl	(revision 2024)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowMap_PS.hlsl	(revision 2179)
@@ -15,9 +15,9 @@
 #define DEPTH_BIAS_VSM  0.001
 #define DEPTH_EPSILON   0.001
-#define DIST_BIAS       0.001
+#define DIST_BIAS       0.1
 #define DIST_BIAS_VSM   0.001
 #define DIST_EPSILON    0.001
 
-const float4 shadowColor = float4(0.85,0.85,0.85,1);
+#define shadowColor float4(0.85,0.85,0.85,1)
 
 float4 shadowMapDepth(LightVPos_OUT IN,
@@ -25,15 +25,13 @@
 {
   float4 light = shadowColor;	
-  float4 pos = (IN.LightVPos / IN.LightVPos.w);
-  if( pos.z > 0.0)
+  if( IN.LightVPos.z > 0.0)
   {
-    pos.xy = (pos.xy + 1.0) / 2.0;
+    float4 pos = (IN.LightVPos / IN.LightVPos.w);
+  	pos.xy = (pos.xy + 1.0) / 2.0;
     pos.y = 1.0 - pos.y;
     float storedDepth = tex2D(shadowMap, pos.xy).r;
-
-    if(pos.z - DEPTH_BIAS <= storedDepth.r)
-      light = 1;
+	pos.z -= DIST_BIAS;
+	light = max(pos.z <= storedDepth.r, shadowColor);    	    
   }
- 
   return light;	
 }
@@ -74,27 +72,26 @@
 }
 
-float4 shadowMapDist(LightCPos_OUT IN,                     
-                     uniform sampler2D shadowMap) : COLOR
+float4 shadowMapDist(LightCPos_OUT IN,
+					//uniform float lightFarPlane,
+					 uniform sampler2D shadowMap) : COLOR
 {
-  float4 light = shadowColor;	
-  float4 pos = (IN.LightVPos / IN.LightVPos.w);
+  float4 light = shadowColor;
   
-  if( pos.z > 0.0)
+  if( IN.LightVPos.z > 0.0)
   {	
-    //float d = length(pos.xy);
+    float4 pos = (IN.LightVPos / IN.LightVPos.w);
+  	//float d = length(pos.xy);
     //light = saturate((1.0 - d)/0.05);		
     //if(d <= 1.0)
-    {
-	float dist = length(IN.LightCPos.xyz);
-	pos.xy = (pos.xy + 1.0) / 2.0;
-	pos.y = 1.0 - pos.y;
-	float storedDist = tex2D(shadowMap, pos.xy).r;
-	dist -= DIST_BIAS;
-
-	if(dist <= storedDist);
-          light = 1;
-     }
-  }  
-	
+    //{
+		float dist = length(IN.LightCPos.xyz) ;
+		pos.xy = (pos.xy + 1.0) / 2.0;
+		pos.y = 1.0 - pos.y;
+		float4 storedDist = tex2D(shadowMap, pos.xy);
+		dist -= DIST_BIAS;
+		light = max(dist <= storedDist.r, shadowColor);    	
+    //}
+  }
+  	
   return light;
 }
@@ -105,30 +102,28 @@
 {
   float4 light = float4(1,1,1,1);
-	
-  float4 pos = (IN.LightVPos / IN.LightVPos.w);
   
-  if( pos.z > 0.0)
+  if( IN.LightVPos.z > 0.0)
   {	
-    //float d = length(pos.xy);
-    //light = saturate((1.0 - d)/0.05);		
-    //if(d <= 1.0)
+    float4 pos = (IN.LightVPos / IN.LightVPos.w);
+  	float d = length(pos.xy);
+    light = saturate((1.0 - d)/0.05);		
+    if(d <= 1.0)
     {
-	float dist = length(IN.LightCPos.xyz) / lightFarPlane;
-	pos.xy = (pos.xy + 1.0) / 2.0;
-	pos.y = 1.0 - pos.y;
-	float4 storedDist = tex2D(shadowMap, pos.xy);
-	dist -= DIST_BIAS_VSM;
-	float lit_factor = light * (dist <= storedDist.r);	
+		float dist = length(IN.LightCPos.xyz) / lightFarPlane;
+		pos.xy = (pos.xy + 1.0) / 2.0;
+		pos.y = 1.0 - pos.y;
+		float4 storedDist = tex2D(shadowMap, pos.xy);
+		dist -= DIST_BIAS_VSM;
+		float lit_factor = light * (dist <= storedDist.r);	
     	 
-	float M1 = storedDist.r;
-	float M2 = storedDist.g;
-	float v2 = min(max(M2 - M1 * M1, 0.0) +  DIST_EPSILON, 1.0);
-	float m_d = M1 - dist;
+		float M1 = storedDist.r;
+		float M2 = storedDist.g;
+		float v2 = min(max(M2 - M1 * M1, 0.0) +  DIST_EPSILON, 1.0);
+		float m_d = M1 - dist;
     	float pmax = v2 / (v2 + m_d * m_d);
 						
     	// Adjust the light color based on the shadow attenuation
-    	light = max(lit_factor, pmax);
-    	
-     }
+    	light = max(lit_factor, pmax);    	
+    }
   }
   else
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program	(revision 2054)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program	(revision 2179)
@@ -119,4 +119,11 @@
 }
 
+fragment_program GTP/Basic/CDistNorm_PS hlsl
+{
+   source GTPBasic_PS.hlsl
+   entry_point CDistNorm
+   target ps_2_0
+}
+
 fragment_program GTP/Basic/Plain_PS hlsl
 {
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_VS.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_VS.hlsl	(revision 2054)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_VS.hlsl	(revision 2179)
@@ -149,5 +149,5 @@
 {
  VPos_OUT OUT;
- OUT.VPos = OUT. VPosition = mul(WorldViewProj, position);
+ OUT.VPos = OUT.VPosition = mul(WorldViewProj, position);
  return OUT;
 }
@@ -224,9 +224,11 @@
 LightVPos_OUT LightVPos(float4 position : POSITION0,
               uniform float4x4 WorldViewProj,
-              uniform float4x4 LightWorldViewProj)
+              uniform float4x4 LightViewProj,
+	      	  uniform float4x4 World)
 {
  LightVPos_OUT OUT;
  OUT.VPos = mul(WorldViewProj, position);
- OUT.LightVPos = mul(LightWorldViewProj, position);
+ float4 WPos = mul(World, position);
+ OUT.LightVPos = mul(LightViewProj, WPos);
  return OUT;
 }
@@ -242,11 +244,13 @@
 LightCPos_OUT LightCPos(float4 position : POSITION0,
               uniform float4x4 WorldViewProj,
-              uniform float4x4 LightWorldViewProj,
-              uniform float4x4 LightWorldView)
+              uniform float4x4 World,
+              uniform float4x4 LightViewProj,
+              uniform float4x4 LightView)
 {
  LightCPos_OUT OUT;
  OUT.VPos = mul(WorldViewProj, position);
- OUT.LightVPos = mul(LightWorldViewProj, position);
- OUT.LightCPos = mul(LightWorldView, position);
- return OUT;
-}
+ float4 WPos = mul(World, position);
+ OUT.LightVPos = mul(LightViewProj, WPos);
+ OUT.LightCPos = mul(LightView, WPos);
+ return OUT;
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material	(revision 2040)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material	(revision 2179)
@@ -115,2 +115,55 @@
  }
 }
+
+material GTP/Basic/Distance_Normalized
+{
+ technique
+ {
+  pass
+  {
+   cull_hardware clockwise
+   vertex_program_ref GTP/Basic/CPos_VS
+   {  
+     param_named_auto WorldViewProj worldviewproj_matrix     
+     param_named_auto WorldView     worldview_matrix
+   } 
+   fragment_program_ref GTP/Basic/CDistNorm_PS
+   {	
+    param_named_auto farPlane far_clip_distance
+   }   
+  }
+ }
+}
+
+material GTP/Basic/Distance_NormalizedCCW : GTP/Basic/Distance_Normalized
+{
+ technique 0
+ {
+  pass 0
+  {
+   cull_hardware anticlockwise   
+  }
+ }
+}
+
+material GTP/Basic/ShadowReciever/Depth
+{
+ technique
+ {
+   pass
+   {
+     lighting off
+     IllumTechniques
+     {
+        RenderTechnique DepthShadowReciever
+		{
+			max_light_count 1
+			vertex_program_name GTP/Basic/LightVPos_VS
+			fragment_program_name GTP/Basic/SM/Depth_PS
+			set_light_view false
+			set_light_farplane false
+		}	
+     }
+   }
+ }
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h	(revision 2175)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h	(revision 2179)
@@ -99,6 +99,6 @@
 		if(scene == 1)
 		{
-		  mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
-		  //mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
+		 // mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
+		  mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
 		}
 		else if(scene == 2)
@@ -109,5 +109,7 @@
     {
 		//createPostproc();
-
+		//std::string occlusion_cfg("OcclusionCulling.cfg");
+		//mSceneMgr->setWorldGeometry(occlusion_cfg);
+		
 		OgreIlluminationManager::getSingleton().setMainCamera(mCamera);
 		OgreIlluminationManager::getSingleton().setMainViewport(mWindow->getViewport(0));
Index: GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h	(revision 2175)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h	(revision 2179)
@@ -96,9 +96,17 @@
 	void createScene(void)
     {
-		createPostproc();
+		//std::string occlusion_cfg("OcclusionCulling.cfg");
+		//mSceneMgr->setWorldGeometry(occlusion_cfg);
+		
+		//createPostproc();
 
 		OgreIlluminationManager::getSingleton().setMainCamera(mCamera);
 		OgreIlluminationManager::getSingleton().setMainViewport(mWindow->getViewport(0));
 		OgreIlluminationManager::getSingleton().setShadowMapSize(512);
+		OgreIlluminationManager::getSingleton().setShadowMapMaterialName("GameTools/ShadowMapDistance");
+		OgreIlluminationManager::getSingleton().setFocusingSM(true);
+	   OgreIlluminationManager::getSingleton().setShadowMapSize(512);
+	   OgreIlluminationManager::getSingleton().setBlurShadowMap(false);
+	   OgreIlluminationManager::getSingleton().setUseLISPSM(false);
 				
 		Root::getSingleton()._setCurrentSceneManager(mSceneMgr);
@@ -113,45 +121,23 @@
 		mSceneMgr->setSkyBox(true, "Examples/EveningSkyBox", 500);
 		
-		SceneNode* rootNode = mSceneMgr->getRootSceneNode();	
+		SceneNode* rootNode = mSceneMgr->getRootSceneNode();
 
 		
 		SceneSerializer s(mSceneMgr);
 		DataStreamPtr inputStream; 				
-		inputStream = ResourceGroupManager::getSingleton().openResource("towers2.level");		
+		inputStream = ResourceGroupManager::getSingleton().openResource("level.txt");	//towers2.level	
 		s.parseScript(inputStream, ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
-		
-	/*	Entity* tower = mSceneMgr->createEntity("tower","tower.mesh");
-		SceneNode* tNode = rootNode->createChildSceneNode("tower");
-		tNode->setScale(10,10,10);
-		tNode->attachObject(tower);
-
-		Entity* tower2 = mSceneMgr->createEntity("tower2","tower.mesh");
-		tower2->setMaterialName("towermaterialBump");
-		SceneNode* tNode2 = rootNode->createChildSceneNode("tower2");
-		tNode2->setScale(10,10,10);
-		tNode2->setPosition(0,0,100);
-		tNode2->attachObject(tower2);*/
-
-	/*	Entity* tower3 = mSceneMgr->createEntity("tower3","tower.mesh");
-		tower3->setMaterialName("towermaterialNoBump");
-		SceneNode* tNode3 = rootNode->createChildSceneNode("tower3");
-		tNode3->setPosition(0,0,-50);
-		tNode3->setScale(10,10,10);
-		tNode3->attachObject(tower3);*/
-
-/*		Entity* lepcso = mSceneMgr->createEntity("lepcso","stairs.mesh");
-		SceneNode* lNode = rootNode->createChildSceneNode("l");
-		lNode->attachObject(lepcso);*/
-	
-		//createPlane("p","lambert1",Vector3(0,-20,0),Vector2(100,100));
+			
+		createPlane("p","GTP/Basic/ShadowReciever/Depth",Vector3(0,0,0),Vector2(1000,1000));
 
 		Light* mainLight = mSceneMgr->createLight("MainLight");
 		mainLight->setType(Light::LT_DIRECTIONAL);
+		mainLight->setCastShadows(true);
         mainLight->setDiffuseColour(ColourValue::White);
 		mainLight->setSpecularColour(ColourValue::White);
 		mainLightNode = rootNode->createChildSceneNode();
 		
-		mainLightNode->setPosition(10,10,0);		
-		mainLight->setPosition(10,10,0);
+		mainLightNode->setPosition(1000,1000,1000);		
+		mainLight->setPosition(1000,1000,1000);
 		mainLight->setPowerScale(5);
 		mainLight->setDirection(-1,-1, -1);
Index: GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 2175)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 2179)
@@ -361,5 +361,5 @@
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("PostProc");
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Basic");
-		ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Diffuse");
+	//	ResourceGroupManager::getSingleton().initialiseResourceGroup("GTP_Diffuse");
 	}
 
@@ -654,5 +654,5 @@
 	   OgreIlluminationManager::getSingleton().setShadowMapSize(512);
 	   OgreIlluminationManager::getSingleton().setBlurShadowMap(true);
-	   OgreIlluminationManager::getSingleton().setShadowMapMaterialName("GameTools/ShadowMapDistance");
+	   OgreIlluminationManager::getSingleton().setShadowMapMaterialName("GTP/Basic/Distance_Normalized");//GameTools/ShadowMapDistance
 	    mSceneMgr->setAmbientLight(ColourValue(0.505 * 0.2, 0.897 * 0.2, 0.914 * 0.2));
 		
@@ -660,5 +660,5 @@
 
      	Entity* object = mSceneMgr->createEntity("object", "buddha.mesh");
-		object->setMaterialName("GTP/Diffuse/Disc2Point");
+		//object->setMaterialName("GTP/Diffuse/Disc2Point");
 		//object->setMaterialName("GameTools/DiffuseP2P");
 		objectNode = rootNode->createChildSceneNode();
Index: GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/include/CausticTest.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/include/CausticTest.h	(revision 2175)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/include/CausticTest.h	(revision 2179)
@@ -149,6 +149,6 @@
 	void chooseSceneManager()
 	{
-		mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
-		//mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
+		mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
 	}
 
@@ -181,6 +181,6 @@
 	void createScene(void)
     {
-	//	std::string terrain_cfg("terrainCulling.cfg");
-	//	mSceneMgr->setWorldGeometry(terrain_cfg);
+		std::string occlusion_cfg("OcclusionCulling.cfg");
+		mSceneMgr->setWorldGeometry(occlusion_cfg);
 		//createPostproc();
 		OgreIlluminationManager::getSingleton().setBlurShadowMap(true);
